# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['AccountDnsSettingsArgs', 'AccountDnsSettings']

@pulumi.input_type
class AccountDnsSettingsArgs:
    def __init__(__self__, *,
                 account_id: pulumi.Input[builtins.str],
                 zone_defaults: Optional[pulumi.Input['AccountDnsSettingsZoneDefaultsArgs']] = None):
        """
        The set of arguments for constructing a AccountDnsSettings resource.
        :param pulumi.Input[builtins.str] account_id: Identifier.
        """
        pulumi.set(__self__, "account_id", account_id)
        if zone_defaults is not None:
            pulumi.set(__self__, "zone_defaults", zone_defaults)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> pulumi.Input[builtins.str]:
        """
        Identifier.
        """
        return pulumi.get(self, "account_id")

    @account_id.setter
    def account_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "account_id", value)

    @property
    @pulumi.getter(name="zoneDefaults")
    def zone_defaults(self) -> Optional[pulumi.Input['AccountDnsSettingsZoneDefaultsArgs']]:
        return pulumi.get(self, "zone_defaults")

    @zone_defaults.setter
    def zone_defaults(self, value: Optional[pulumi.Input['AccountDnsSettingsZoneDefaultsArgs']]):
        pulumi.set(self, "zone_defaults", value)


@pulumi.input_type
class _AccountDnsSettingsState:
    def __init__(__self__, *,
                 account_id: Optional[pulumi.Input[builtins.str]] = None,
                 zone_defaults: Optional[pulumi.Input['AccountDnsSettingsZoneDefaultsArgs']] = None):
        """
        Input properties used for looking up and filtering AccountDnsSettings resources.
        :param pulumi.Input[builtins.str] account_id: Identifier.
        """
        if account_id is not None:
            pulumi.set(__self__, "account_id", account_id)
        if zone_defaults is not None:
            pulumi.set(__self__, "zone_defaults", zone_defaults)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Identifier.
        """
        return pulumi.get(self, "account_id")

    @account_id.setter
    def account_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "account_id", value)

    @property
    @pulumi.getter(name="zoneDefaults")
    def zone_defaults(self) -> Optional[pulumi.Input['AccountDnsSettingsZoneDefaultsArgs']]:
        return pulumi.get(self, "zone_defaults")

    @zone_defaults.setter
    def zone_defaults(self, value: Optional[pulumi.Input['AccountDnsSettingsZoneDefaultsArgs']]):
        pulumi.set(self, "zone_defaults", value)


@pulumi.type_token("cloudflare:index/accountDnsSettings:AccountDnsSettings")
class AccountDnsSettings(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_id: Optional[pulumi.Input[builtins.str]] = None,
                 zone_defaults: Optional[pulumi.Input[Union['AccountDnsSettingsZoneDefaultsArgs', 'AccountDnsSettingsZoneDefaultsArgsDict']]] = None,
                 __props__=None):
        """
        ## Example Usage

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] account_id: Identifier.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AccountDnsSettingsArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        :param str resource_name: The name of the resource.
        :param AccountDnsSettingsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AccountDnsSettingsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_id: Optional[pulumi.Input[builtins.str]] = None,
                 zone_defaults: Optional[pulumi.Input[Union['AccountDnsSettingsZoneDefaultsArgs', 'AccountDnsSettingsZoneDefaultsArgsDict']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AccountDnsSettingsArgs.__new__(AccountDnsSettingsArgs)

            if account_id is None and not opts.urn:
                raise TypeError("Missing required property 'account_id'")
            __props__.__dict__["account_id"] = account_id
            __props__.__dict__["zone_defaults"] = zone_defaults
        super(AccountDnsSettings, __self__).__init__(
            'cloudflare:index/accountDnsSettings:AccountDnsSettings',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            account_id: Optional[pulumi.Input[builtins.str]] = None,
            zone_defaults: Optional[pulumi.Input[Union['AccountDnsSettingsZoneDefaultsArgs', 'AccountDnsSettingsZoneDefaultsArgsDict']]] = None) -> 'AccountDnsSettings':
        """
        Get an existing AccountDnsSettings resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] account_id: Identifier.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AccountDnsSettingsState.__new__(_AccountDnsSettingsState)

        __props__.__dict__["account_id"] = account_id
        __props__.__dict__["zone_defaults"] = zone_defaults
        return AccountDnsSettings(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> pulumi.Output[builtins.str]:
        """
        Identifier.
        """
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter(name="zoneDefaults")
    def zone_defaults(self) -> pulumi.Output[Optional['outputs.AccountDnsSettingsZoneDefaults']]:
        return pulumi.get(self, "zone_defaults")

