# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetZeroTrustDevicePostureIntegrationResult',
    'AwaitableGetZeroTrustDevicePostureIntegrationResult',
    'get_zero_trust_device_posture_integration',
    'get_zero_trust_device_posture_integration_output',
]

@pulumi.output_type
class GetZeroTrustDevicePostureIntegrationResult:
    """
    A collection of values returned by getZeroTrustDevicePostureIntegration.
    """
    def __init__(__self__, account_id=None, config=None, id=None, integration_id=None, interval=None, name=None, type=None):
        if account_id and not isinstance(account_id, str):
            raise TypeError("Expected argument 'account_id' to be a str")
        pulumi.set(__self__, "account_id", account_id)
        if config and not isinstance(config, dict):
            raise TypeError("Expected argument 'config' to be a dict")
        pulumi.set(__self__, "config", config)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if integration_id and not isinstance(integration_id, str):
            raise TypeError("Expected argument 'integration_id' to be a str")
        pulumi.set(__self__, "integration_id", integration_id)
        if interval and not isinstance(interval, str):
            raise TypeError("Expected argument 'interval' to be a str")
        pulumi.set(__self__, "interval", interval)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> builtins.str:
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter
    def config(self) -> 'outputs.GetZeroTrustDevicePostureIntegrationConfigResult':
        """
        The configuration object containing third-party integration information.
        """
        return pulumi.get(self, "config")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        API UUID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="integrationId")
    def integration_id(self) -> Optional[builtins.str]:
        """
        API UUID.
        """
        return pulumi.get(self, "integration_id")

    @property
    @pulumi.getter
    def interval(self) -> builtins.str:
        """
        The interval between each posture check with the third-party API. Use `m` for minutes (e.g. `5m`) and `h` for hours (e.g. `12h`).
        """
        return pulumi.get(self, "interval")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the device posture integration.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of device posture integration.
        Available values: "workspace*one", "crowdstrike*s2s", "uptycs", "intune", "kolide", "tanium*s2s", "sentinelone*s2s", "custom_s2s".
        """
        return pulumi.get(self, "type")


class AwaitableGetZeroTrustDevicePostureIntegrationResult(GetZeroTrustDevicePostureIntegrationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetZeroTrustDevicePostureIntegrationResult(
            account_id=self.account_id,
            config=self.config,
            id=self.id,
            integration_id=self.integration_id,
            interval=self.interval,
            name=self.name,
            type=self.type)


def get_zero_trust_device_posture_integration(account_id: Optional[builtins.str] = None,
                                              integration_id: Optional[builtins.str] = None,
                                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetZeroTrustDevicePostureIntegrationResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_zero_trust_device_posture_integration = cloudflare.get_zero_trust_device_posture_integration(account_id="699d98642c564d2e855e9661899b7252",
        integration_id="f174e90a-fafe-4643-bbbc-4a0ed4fc8415")
    ```


    :param builtins.str integration_id: API UUID.
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    __args__['integrationId'] = integration_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('cloudflare:index/getZeroTrustDevicePostureIntegration:getZeroTrustDevicePostureIntegration', __args__, opts=opts, typ=GetZeroTrustDevicePostureIntegrationResult).value

    return AwaitableGetZeroTrustDevicePostureIntegrationResult(
        account_id=pulumi.get(__ret__, 'account_id'),
        config=pulumi.get(__ret__, 'config'),
        id=pulumi.get(__ret__, 'id'),
        integration_id=pulumi.get(__ret__, 'integration_id'),
        interval=pulumi.get(__ret__, 'interval'),
        name=pulumi.get(__ret__, 'name'),
        type=pulumi.get(__ret__, 'type'))
def get_zero_trust_device_posture_integration_output(account_id: Optional[pulumi.Input[builtins.str]] = None,
                                                     integration_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetZeroTrustDevicePostureIntegrationResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_zero_trust_device_posture_integration = cloudflare.get_zero_trust_device_posture_integration(account_id="699d98642c564d2e855e9661899b7252",
        integration_id="f174e90a-fafe-4643-bbbc-4a0ed4fc8415")
    ```


    :param builtins.str integration_id: API UUID.
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    __args__['integrationId'] = integration_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('cloudflare:index/getZeroTrustDevicePostureIntegration:getZeroTrustDevicePostureIntegration', __args__, opts=opts, typ=GetZeroTrustDevicePostureIntegrationResult)
    return __ret__.apply(lambda __response__: GetZeroTrustDevicePostureIntegrationResult(
        account_id=pulumi.get(__response__, 'account_id'),
        config=pulumi.get(__response__, 'config'),
        id=pulumi.get(__response__, 'id'),
        integration_id=pulumi.get(__response__, 'integration_id'),
        interval=pulumi.get(__response__, 'interval'),
        name=pulumi.get(__response__, 'name'),
        type=pulumi.get(__response__, 'type')))
