# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetZeroTrustGatewaySettingsResult',
    'AwaitableGetZeroTrustGatewaySettingsResult',
    'get_zero_trust_gateway_settings',
    'get_zero_trust_gateway_settings_output',
]

@pulumi.output_type
class GetZeroTrustGatewaySettingsResult:
    """
    A collection of values returned by getZeroTrustGatewaySettings.
    """
    def __init__(__self__, account_id=None, created_at=None, id=None, settings=None, updated_at=None):
        if account_id and not isinstance(account_id, str):
            raise TypeError("Expected argument 'account_id' to be a str")
        pulumi.set(__self__, "account_id", account_id)
        if created_at and not isinstance(created_at, str):
            raise TypeError("Expected argument 'created_at' to be a str")
        pulumi.set(__self__, "created_at", created_at)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if settings and not isinstance(settings, dict):
            raise TypeError("Expected argument 'settings' to be a dict")
        pulumi.set(__self__, "settings", settings)
        if updated_at and not isinstance(updated_at, str):
            raise TypeError("Expected argument 'updated_at' to be a str")
        pulumi.set(__self__, "updated_at", updated_at)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> builtins.str:
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> builtins.str:
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def settings(self) -> 'outputs.GetZeroTrustGatewaySettingsSettingsResult':
        """
        Account settings
        """
        return pulumi.get(self, "settings")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> builtins.str:
        return pulumi.get(self, "updated_at")


class AwaitableGetZeroTrustGatewaySettingsResult(GetZeroTrustGatewaySettingsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetZeroTrustGatewaySettingsResult(
            account_id=self.account_id,
            created_at=self.created_at,
            id=self.id,
            settings=self.settings,
            updated_at=self.updated_at)


def get_zero_trust_gateway_settings(account_id: Optional[builtins.str] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetZeroTrustGatewaySettingsResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_zero_trust_gateway_settings = cloudflare.get_zero_trust_gateway_settings(account_id="699d98642c564d2e855e9661899b7252")
    ```
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('cloudflare:index/getZeroTrustGatewaySettings:getZeroTrustGatewaySettings', __args__, opts=opts, typ=GetZeroTrustGatewaySettingsResult).value

    return AwaitableGetZeroTrustGatewaySettingsResult(
        account_id=pulumi.get(__ret__, 'account_id'),
        created_at=pulumi.get(__ret__, 'created_at'),
        id=pulumi.get(__ret__, 'id'),
        settings=pulumi.get(__ret__, 'settings'),
        updated_at=pulumi.get(__ret__, 'updated_at'))
def get_zero_trust_gateway_settings_output(account_id: Optional[pulumi.Input[builtins.str]] = None,
                                           opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetZeroTrustGatewaySettingsResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_zero_trust_gateway_settings = cloudflare.get_zero_trust_gateway_settings(account_id="699d98642c564d2e855e9661899b7252")
    ```
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('cloudflare:index/getZeroTrustGatewaySettings:getZeroTrustGatewaySettings', __args__, opts=opts, typ=GetZeroTrustGatewaySettingsResult)
    return __ret__.apply(lambda __response__: GetZeroTrustGatewaySettingsResult(
        account_id=pulumi.get(__response__, 'account_id'),
        created_at=pulumi.get(__response__, 'created_at'),
        id=pulumi.get(__response__, 'id'),
        settings=pulumi.get(__response__, 'settings'),
        updated_at=pulumi.get(__response__, 'updated_at')))
